package com.ispntest;

import java.io.IOException;

import org.infinispan.configuration.cache.CacheMode;
import org.infinispan.configuration.cache.ConfigurationBuilder;
import org.infinispan.configuration.global.GlobalConfigurationBuilder;
import org.infinispan.manager.DefaultCacheManager;
import org.infinispan.manager.EmbeddedCacheManager;
import org.infinispan.util.logging.Log;
import org.infinispan.util.logging.LogFactory;

@SuppressWarnings("unused")
public abstract class AbstractNode {
	public static final int CLUSTER_SIZE = 2;
	private Log log = LogFactory.getLog(AbstractNode.class);

	private final EmbeddedCacheManager cacheManager;

	public AbstractNode() {
		try {
			this.cacheManager = new DefaultCacheManager("infinispan.xml");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

	protected EmbeddedCacheManager getCacheManager() {
		return cacheManager;
	}

	protected void waitForClusterToForm() {
		// Wait for the cluster to form, erroring if it doesn't form after the timeout

		log.info("Waiting for cluster of " + CLUSTER_SIZE + " to form...");

		if (!ClusterValidation.waitForClusterToForm(getCacheManager(), getNodeId(), CLUSTER_SIZE)) {
			throw new IllegalStateException("Error forming cluster, check the log");
		}
	}

	protected abstract int getNodeId();
}
